# PyRez

**PyRez** is Python-based wrapper for [Hi-Rez](http://www.hirezstudios.com/) API that supports *[Smite](https://www.smitegame.com/)* and *[Paladins](https://www.paladins.com/)*.

## Requirements
* [Python](http://python.org) 3.5 (or higher)
    * The following libraries are required: `requests` and `requests-aeaweb`
- [Access](https://fs12.formsite.com/HiRez/form48/secure_index.html) to Hi-Rez Studios' API

Detailed documentation is in the "docs" directory.

## Installation
The easiest way to install **Py-rez** is using `pip`, Python's package manager:

```
pip install -U pyrez
```

The required dependencies will be installed automatically. After that, you can use the library using `import pyrez`.

## Example

```py
from pyrez import API
from API import PaladinsAPI

client = PaladinsAPI ("YOUR_DEV_ID", "YOUR_AUTH_KEY")
godsRanks = client.getGodRanks ("FeyRazzle")

if godsRanks is not None:
    for godRank in godsRanks:
        print(godRank.getWinratio ())
```

This example will print the winrate with every gods of player **FeyRazzle**.
